<?php

/**
 * generar_aportes_cont actions.
 *
 * @package    nomina
 * @subpackage generar_aportes_cont
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class generar_aportes_contActions extends sfActions {

    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /**
         * Abrir nueva conexion con la Base de Datos
         */
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();


        /*
         * Manejar Errores
         */
        try {


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);


            /**
             * Consultar salario minimo
             */
            $salario_minimo = 550000;
            //Sql
            $sql = <<<EOD
(select nvl(valor_mensual, 0) as valor_mensual from no_smdlv where vigencia = extract(year from sysdate))  
EOD;
            //Ejecutar SQL
            $record_smlv = CN_TABLE::executeSQL($sql);

            if (count($record_smlv) > 0) {
                $salario_minimo = round($record_smlv[0]['valor_mensual'], -3);
            }

            /*
             * Obtener consultas glodal
             */
            //Sql
            $sql = <<<EOD
select * from NO_CONSULTA 
EOD;
            //Ejecutar SQL
            $record_consul = CN_TABLE::executeSQL($sql);
            $record_consulta = array();

            if (count($record_consul) > 0) {
                foreach ($record_consul as $key => $value) {
                    $record_consulta[$value['caracter']] = $value;

//                    $this->logMessage("Caracter - " . $value['caracter']);
                }
            }
//            $this->logMessage("Consulta - " . $record_consulta['M']['consulta']);
//            die();

            /**
             * Operacion
             */
            if (isset($request['accion_filtro'])) {
                $accion_filtro = true;
            } else {
                $accion_filtro = false;
            }
//            $accion_filtro = true;


            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            //ordenar consulta
            if (isset($request['_sortBy'])) {
                $sortBy = " Order by " . $request['_sortBy'];
            } else {
                $sortBy = ' Order by num_doc, id_clase_fondo ';
            }

            /*
             * Variables
             */
            $vigencia = date('Y');
            $mes = date('m');
            $id_periodo = $request['id_periodo_filtro'];
            $id_periodo_actual = $request['id_periodo'];
            $progress_key = $request['progress_key'] . $request['username'];

            //Funcionario num_doc
            $num_doc = null;
            $whereFuncionarioNumDoc = "";
            if (isset($request['num_doc'])) {
                $num_doc = $request['num_doc'];
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            }
            //Funcionario id_tipo_doc 
            $id_tipo_doc = null;
            $whereFuncionarioTipoDoc = "";
            if (isset($request['id_tipo_doc'])) {
                $id_tipo_doc = $request['id_tipo_doc'];
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            }
            //id_clase_fondo
            $whereClaseFondo = "";
            if (isset($request['id_clase_fondo'])) {
                $whereClaseFondo = " AND tab0.id_clase_fondo = " . $request['id_clase_fondo'];
            }
            //id_mae_fondos
            $whereMaestroFondos = "";
            if (isset($request['id_mae_fondos'])) {
                $whereMaestroFondos = " AND tab0.id_mae_fondos = " . $request['id_mae_fondos'];
            }

            //solo imprime log la primera vez de consulta
            if ($rowStart == 0) {
                $this->logMessage("Generar aportes.");

                if ($accion_filtro) {

                    //sentencia sql
                    $sql = <<<EOD
delete from CONT_LIQUIDA_APORTE tab0 
where tab0.id_periodo = $id_periodo 
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
EOD;
                    //ejecuta y obtiene el resultado del sql
                    CN_TABLE::executeSQL($sql);

                    /*
                     * Verifique que el funcionario este afiliado a todos los fondos.
                     * Incidente #35692, filtro de pasante segun tipo periodo - 20231130
                     */
                    //Sql
                    $sql = <<<EOD
select 
tab0.num_doc, 
count(tab0.id_afilia_fondo) 

from cont_afilia_fondo tab0

left join contratista cont on cont.id_tipo_doc = tab0.id_tipo_doc and cont.num_doc = tab0.num_doc

where 
tab0.estado = 1
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
and cont.id_tipo_contratista = (select case when id_tipo_periodo = 9 then 1 
    when id_tipo_periodo = 10 then 2 
        else 0 end as id_tipo_contratista from no_periodo where id_periodo = $id_periodo)

having count(tab0.id_afilia_fondo) < (1)

group by tab0.num_doc 
EOD;
                    //Ejecutar SQL
                    $record_total = CN_TABLE::executeSQL($sql);
                    if (count($record_total) == 0) {

                        /*
                         * Incidente #35692, filtro de pasante segun tipo periodo - 20231130
                         */
                        //sentencia sql
                        $sql = <<<EOD
INSERT INTO CONT_LIQUIDA_APORTE (ID_CLASE_FONDO,ID_MAE_FONDOS,ID_CONCEP_NOMINA,ID_TIPO_DOC,NUM_DOC,VALOR_BASE,NUM_DIAS,
APORTE_FUNC,APORTE_PATRONO,ID_TIPO_APORTE,PORCENTAJE_FUNC,PORCENTAJE_PATRONO,TARIFA,ID_PERIODO)


select 
afilia.id_clase_fondo as id_clase_fondo,
fondo.id_mae_fondos as id_mae_fondos,
conceptos.id_concep_nomina as id_concep_nomina,
tab0.id_tipo_doc as id_tipo_doc,
tab0.num_doc as num_doc,
0 as valor_base,

/*
Valida mes de febrero para los 30 dias - 20140127                                
*/                                
case                                 
when (SELECT ID_MESES FROM NO_PERIODO WHERE ID_PERIODO = $id_periodo) = 2 
and afilia.fecha_ingreso <= trunc(( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo),'dd/mm/yyyy') ))
and afilia.fecha_retiro >= trunc(last_day( TO_DATE('01/'|| (SELECT LPAD(ID_MESES,2,'0') ||'/'||ID_ANHOS FROM NO_PERIODO WHERE ID_PERIODO = $id_periodo) ,'dd/mm/yyyy') ))
then 30                               
else 
--dias_rango_mes_sin_treintayuno(afilia.fecha_ingreso,afilia.fecha_retiro, (select id_meses from no_periodo where id_periodo = $id_periodo)) as dias,
FECHA_RANGO_SIN_TREINTAYUNO (

case when afilia.fecha_ingreso <= trunc(( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo),'dd/mm/yyyy') ))
then trunc(( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo),'dd/mm/yyyy') )) 
else afilia.fecha_ingreso end

,
case 

when afilia.fecha_retiro >= trunc(last_day( TO_DATE('01/'|| (SELECT LPAD(ID_MESES,2,'0') ||'/'||ID_ANHOS FROM NO_PERIODO WHERE ID_PERIODO = $id_periodo) ,'dd/mm/yyyy') )) 
then trunc(last_day( TO_DATE('01/'|| (SELECT LPAD(ID_MESES,2,'0') ||'/'||ID_ANHOS FROM NO_PERIODO WHERE ID_PERIODO = $id_periodo) ,'dd/mm/yyyy') )) 
else afilia.fecha_retiro  end


) end as num_dias,
                                
0 as aporte_func,
0 as aporte_patrono,
afilia.id_tipo_aporte as id_tipo_aporte,
conceptos.porcentaje_func as porcentaje_func,
conceptos.porcentaje_patrono as porcentaje_patrono,
conceptos.tarifa as tarifa,
$id_periodo as id_periodo
                                
from contratista tab0

--join cont_contrato tab5 on tab5.id_tipo_doc = tab0.id_tipo_doc and tab5.num_doc = tab0.num_doc
left join (
  SELECT
   aut.*,
   ROW_NUMBER() OVER (
    partition by aut.num_doc
    ORDER BY aut.estado DESC
   ) AS rn
  from cont_contrato aut
)tab5
on tab5.id_tipo_doc = tab0.id_tipo_doc 
and tab5.num_doc = tab0.num_doc
and tab5.rn = 1

join cont_afilia_fondo afilia 
on afilia.id_tipo_doc = tab0.id_tipo_doc 
and afilia.num_doc = tab0.num_doc 
and (
  (select fecha_fin from no_periodo where id_periodo =  $id_periodo)
  between afilia.fecha_ingreso and nvl( afilia.fecha_retiro, trunc(last_day( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy') )) )
  or
  (select fecha_ini from no_periodo where id_periodo =  $id_periodo)
  between afilia.fecha_ingreso and nvl( afilia.fecha_retiro, trunc(( to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy') )) )
)
--and afilia.estado = 1

join no_mae_fondos fondo ON fondo.id_mae_fondos = afilia.id_mae_fondos

left join(

    select 
    deta.id_tipo_aporte, deta.porcentaje_func,deta.porcentaje_patrono,descto.id_clase_fondo,
    foncon.id_mae_fondos,foncon.id_concep_nomina, (deta.porcentaje_func+deta.porcentaje_patrono) as tarifa,
    deta.rango_desde, deta.rango_hasta,(select valor_mensual * deta.rango_hasta from no_smdlv where vigencia = extract(year from sysdate)) AS SALARIO, descto.id_descuento_ss
    from no_descto_detalle deta
    left join no_descuento_ss descto ON descto.id_descuento_ss = deta.id_descuento_ss
    left join no_fondo_concepto foncon ON foncon.id_descuento_ss = descto.id_descuento_ss

) conceptos ON conceptos.id_tipo_aporte = afilia.id_tipo_aporte 
and conceptos.id_clase_fondo = afilia.id_clase_fondo 
and conceptos.id_mae_fondos = afilia.id_mae_fondos
--and case when conceptos.id_descuento_ss = 2 then liquida.valor else conceptos.salario+1 end > conceptos.salario

where tab5.estado = 1 
and conceptos.id_concep_nomina is not null 
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
                                
and tab0.id_tipo_contratista = (select case when id_tipo_periodo = 9 then 1 
    when id_tipo_periodo = 10 then 2 
        else 0 end as id_tipo_contratista from no_periodo where id_periodo = $id_periodo)                                
                                
and (
  tab5.fecha_fin >= trunc(/*last_day*/( TO_DATE('01/'|| (SELECT LPAD(ID_MESES,2,'0') ||'/'||ID_ANHOS FROM NO_PERIODO WHERE ID_PERIODO = $id_periodo) ,'dd/mm/yyyy') ))
 /*
  and tab5.fecha_fin
      between to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy')
      and trunc(last_day( TO_DATE('01/'|| (SELECT LPAD(ID_MESES,2,'0') ||'/'||ID_ANHOS FROM NO_PERIODO WHERE ID_PERIODO = $id_periodo_actual) ,'dd/mm/yyyy') ))
 */
)
EOD;

//and tab0.actual = 1 
//and afilia.estado = 1
                        //ejecuta y obtiene el resultado del sql
                        CN_TABLE::executeSQL($sql);


                        /*
                         * Tag_retro para cuando es retroactivo, para retencion tiene encuenta todo el mes con lo del retroactivo - 20150610
                         */
                        $sql = <<<EOD
SELECT 
$salario_minimo as salario_minimo,
1 as tag,    
0 as tg_retro,
tab0.num_dias as num_dias, 
0 as wdiasv,
tab0.porcentaje_func,
tab0.porcentaje_patrono,
tab0.aporte_func,
tab0.aporte_patrono,
tab0.id_tipo_doc,
tab0.num_doc, 
tab0.id_clase_fondo, 
tab0.id_concep_nomina, 
tab1.id_agrup_concepto, 
tab2.id_meses, 
tab2.id_anhos,
tab0.tarifa, 
tab0.id_liquida_aporte, 
tab0.id_periodo as periodo
FROM CONT_LIQUIDA_APORTE tab0
LEFT JOIN NO_CLASE_FONDO tab1 ON tab1.id_clase_fondo = tab0.id_clase_fondo
LEFT JOIN NO_PERIODO tab2 ON tab2.id_periodo = tab0.id_periodo
                             
WHERE tab0.ID_PERIODO = $id_periodo
$whereFuncionarioNumDoc $whereFuncionarioTipoDoc 
                                
order by
tab0.num_doc    
EOD;


                        /**
                         * Recorre los registros de no_liquida_aporte
                         */
                        $records = CN_TABLE::executeSQL($sql);



                        $this->conn->commit();


                        $i = 1;
                        $nom_conceptos_a_procesar = count($records);

                        // Antes de inicar el proceso largo
                        $brecha = 1;
                        if ($nom_conceptos_a_procesar > 100)
                            $brecha = $nom_conceptos_a_procesar - (0.99 * $nom_conceptos_a_procesar);

                        $this->logMessage("[generar_aportes] nom_conceptos_a_procesar: " . $nom_conceptos_a_procesar);

                        /*
                         * Log liquidacion.log registros uno a uno - Funcionarios
                         */
                        $logPath = sfConfig::get('sf_log_dir') . '/liquidacion.log';
                        $custom_logger = new sfFileLogger(new sfEventDispatcher(), array('file' => $logPath));

                        foreach ($records as $record) {

                            /**
                             * Abrir nueva conexion con la Base de Datos
                             */
                            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                            $this->conn->beginTransaction();

                            /*
                             * Variables del record
                             */
                            $id_liquida_aporte = $record['id_liquida_aporte'];
                            $id_tipo_doc = $record['id_tipo_doc'];
                            $num_doc = $record['num_doc'];
                            $id_clase_fondo = $record['id_clase_fondo'];
                            $id_concep_nomina = $record['id_concep_nomina'];
                            $id_agrup_concepto = $record['id_agrup_concepto'];
                            $id_meses = $record['id_meses'];
                            $id_anhos = $record['id_anhos'];
                            $tarifa = $record['tarifa'];
                            $aporte_func = $record['aporte_func'];


                            // Termina procesamiento de concepto
                            $custom_logger->info("Procesado $i de $nom_conceptos_a_procesar conceptos. Documento: " . $num_doc . "\n");


                            $this->logMessage("---------------------------------------------------------------------");


                            // Guardar un valor en el proceso largo
                            if ($i % $brecha == 0) {
                                MemcacheHandler::getInstance()->set($progress_key, round(($i / $nom_conceptos_a_procesar) * 100, 0));
                            }

                            $this->logMessage("[generar_aportes] Existen aportes.");


                            $valor_base_vac = 0;
                            $sueldo = 0;

                            //sentencia sql
                            $sql = <<<EOD
select 
nvl(tab0.sueldo ,0) as sueldo
from cont_contrato tab0
where tab0.estado = 1
and tab0.num_doc = $num_doc
and tab0.id_tipo_doc = $id_tipo_doc
and (
  tab0.fecha_fin >= trunc(/*last_day*/( TO_DATE('01/'|| (SELECT LPAD(ID_MESES,2,'0') ||'/'||ID_ANHOS FROM NO_PERIODO WHERE ID_PERIODO = $id_periodo) ,'dd/mm/yyyy') ))
 /*
  and tab0.fecha_fin
      between to_date('01/'|| (select lpad(id_meses,2,'0') ||'/'||id_anhos from no_periodo where id_periodo = $id_periodo) ,'dd/mm/yyyy')
      and trunc(last_day( TO_DATE('01/'|| (SELECT LPAD(ID_MESES,2,'0') ||'/'||ID_ANHOS FROM NO_PERIODO WHERE ID_PERIODO = $id_periodo_actual) ,'dd/mm/yyyy') ))
 */
)
EOD;


                            //ejecuta y obtiene el resultado del sql
                            $records_sueldo = CN_TABLE::executeSQL($sql);

                            if (count($records_sueldo) > 0) {
                                $sueldo = $records_sueldo[0]['sueldo'];
                            }

                            //Se toma el 40 porciento del sueldo - 20130725
                            $sueldo = $sueldo * 40 / 100;

                            $arrayParametros = array();

                            // Se agrega al calculo la formula (({A39}/30)*$wdiasv)) - 20130517
                            // Toma los dias de vacaciones para el mes a liquidar
                            // Se agrega el calculo por la cantidad de dias del periodo - 20130823
                            $wdiasv = $record['wdiasv'];
                            $num_dias = $record['num_dias'];
                            $formula = "(($sueldo/30*$num_dias)+($valor_base_vac))";
                            $this->logMessage("[Liquidación Agrupación] Formula Inicial: " . $formula);

                            /*
                             * Reemplaza en la consulta los filtros y valores del SQL, que vienen en el record
                             * Ejemplo: select raz_soc from id_cia where id_cia = $id_cia
                             * Reemplaza $id_cia por el valor en el record
                             */
                            $formula = CN_TABLE::reemplazoConsulta($formula, $record);
                            $this->logMessage("[Liquidación Agrupación] Formula consulta los filtros: " . $formula);

                            /*
                             * Cambio en la formula de A por (C1+C2)
                             */
//                            $vars = array();
//
//                            CN_TABLE::getVarsInFormula($vars, $formula);
//
////        var_dump($vars);
//
//                            foreach ($vars as $var) {
//                                if (substr($var, 0, 1) == 'A') {
//                                    /*
//                                     * Cambio de A1 por relacion con los conceptos C1
//                                     * Ejemplo: 'A1' => '0'
//                                     */
//                                    $agrup = $this->reemplazoAgrupacion(substr($var, 1));
//                                    $this->logMessage("[Liquidación Agrupación] Agrupacion: " . $agrup);
//
//                                    $formula = str_replace('{' . $var . '}', $agrup, $formula);
//                                }
//                            }
//                            $this->logMessage("[Liquidación Agrupación] Formula parametrosFormula y reemplazoAgrupacion: " . $formula);
//
//
//
//                            /*
//                             * Cambio de A1 por relacion con los conceptos C1
//                             * Ejemplo: 'A1' => '0'
//                             */
////                            $agrup = $this->reemplazoAgrupacion($id_agrup_concepto);
////                            $this->logMessage("[Liquidación Agrupación] Agrupacion: " . $agrup);
//
//
//                            /*
//                             * Parser de la formula para obtener parametros(variables)
//                             * Ejemplo: 'A1' => '0',
//                             * 'C1' => '0'
//                             */
////                            $arrayParametros = $this->parametrosFormula($agrup);
//                            $arrayParametros = $this->parametrosFormula($formula);
//
//
//                            /*
//                             * Obtener resultados de los parametros(variables)
//                             * Ejemplo: $arrayParametros = array(
//                             * 'C1' => '0',
//                             * 'C2' => '0'
//                             * );
//                             */
//                            $arrayParametros = $this->resultadoParametros($arrayParametros, $record, $record_consulta);
//
//
//                            /*
//                             * Reemplazo de parametros(variables) a la formula
//                             * Ejemplo: $arrayParametros = array(
//                             * 'C1' => '1100',
//                             * 'C2' => '55'
//                             * );
//                             */
////                            $formula = $agrup;
//                            $formula = $this->reemplazoParametros($formula, $arrayParametros);
                            /*
                             * Ejecutar fórmula
                             * Ejemplo: ( 0 == 0 ? {C1} * $porcentaje : false )
                             * Retorna false  si no cumple con la condicion
                             */
                            $formula = str_replace('{', ' ', $formula);
                            $formula = str_replace('}', ' ', $formula);
                            $result = CN_TABLE::aplicarEval($formula);

                            /*
                             * No cumple con la condicion
                             */
//                if ($result === false) {
                            if ($result == '-9999' || $result == -9999) {
                                $this->logMessage("[Liquidación Agrupación] Formula No cumple con la condicion: " . $formula);
                                $result = 0;
                            }

                            $valor_base = round($result, -3);

                            //Base del valor smlv por los dias del funcionario - 20130625
                            $valor_base_smlv = round(($salario_minimo / 30) * $num_dias, -3);

                            //Valor base no puede superar 25 salarios minimos
                            if ($valor_base > ($salario_minimo * 25)) {
                                $this->logMessage("[Liquidación Agrupación] Valor base no puede superar 25 salarios minimos.");
                                $valor_base = round(($salario_minimo * 25) - 1, -3);
                            }
                            //Valida salario minimo - 20130523
                            elseif ($valor_base < $valor_base_smlv) {
                                //Solo para ARP id_clase_fondo 3 - 20130523
                                if ($id_clase_fondo == 3) {
                                    $this->logMessage("[Liquidación Agrupación] ARP id_clase_fondo 3.");
                                    $valor_base = $valor_base_smlv;
                                }
                            }

                            //round ( $valor_base * tarifa / 100 , -2)
                            $valor_calculo = ( $valor_base * $tarifa / 100 );

                            if (($valor_calculo + 50) == round($valor_calculo, -2)) {
                                $valor_calculo = $valor_calculo - 50;
                            } else {
                                $valor_calculo = round($valor_calculo, -2);
                            }

                            $aporte_func = $aporte_func;


                            /*
                             * Actualizar registro aporte
                             */
                            //sentencia sql
                            $sql = <<<EOD
update CONT_LIQUIDA_APORTE set valor_base = $valor_base
        , aporte_patrono =  case when porcentaje_patrono > 0 then $valor_calculo - $aporte_func else 0 end 
            , aporte_func =  case when porcentaje_patrono = 0 then $valor_calculo else $aporte_func end
    where id_liquida_aporte = $id_liquida_aporte 
EOD;
                            //ejecuta y obtiene el resultado del sql
                            CN_TABLE::executeSQL($sql);


                            $i++;

                            $this->conn->commit();
                        }
                        MemcacheHandler::getInstance()->set($progress_key, 100);
                    } else {


                        $this->conn->commit();

                        MemcacheHandler::getInstance()->set($progress_key, 100);
                        $mensaje = "Verifique que el funcionario(s) este afiliado a todos los fondos.";

                        $this->status = 2;
                        $this->mensajeError = $mensaje;
                    }
                } else {
                    $this->conn->commit();
                }
            } else {
                $this->conn->commit();
            }




            /**
             * Abrir nueva conexion con la Base de Datos
             */
            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

SELECT * 

FROM (

    select 

    tab0.id_liquida_aporte,
    tab0.id_clase_fondo,
    tab0.id_mae_fondos,
    tab0.id_concep_nomina,
    tab0.id_tipo_doc,
    tab0.num_doc,
    tab0.valor_base,
    tab0.num_dias,
    tab0.aporte_func,
    tab0.aporte_patrono,
    tab0.id_tipo_aporte,
    tab0.porcentaje_func,
    tab0.porcentaje_patrono,
    tab0.tarifa,
    tab0.id_periodo,
    tab1.razon_social as fondo, 
    tab2.descripcion as clase_fondo,
    tab3.codigo||' - '||tab3.descripcion as concepto,
    tab4.razon_social as nombre_apellido,
    tab4.num_doc || ' - ' || tab4.razon_social as nombre_completo

    from cont_liquida_aporte  tab0
    left join CONTRATISTA tab4 ON tab4.id_tipo_doc = tab0.id_tipo_doc and tab4.num_doc = tab0.num_doc            
    left join NO_MAE_FONDOS tab1 ON tab1.id_mae_fondos = tab0.id_mae_fondos
    left join NO_CLASE_FONDO tab2 ON tab2.id_clase_fondo = tab0.id_clase_fondo
    left join NO_CONCEP_NOMINA tab3 ON tab3.id_concep_nomina = tab0.id_concep_nomina
    WHERE tab0.id_periodo = $id_periodo 
    $whereFuncionarioNumDoc $whereFuncionarioTipoDoc
    $whereClaseFondo $whereMaestroFondos
    )

)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            /*
             * Obtiene las vigencias/periodo que se encuentre en la tabla de saldos
             */
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
    
SELECT * 

FROM (

    select 

    tab0.id_liquida_aporte,
    tab0.id_clase_fondo,
    tab0.id_mae_fondos,
    tab0.id_concep_nomina,
    tab0.id_tipo_doc,
    tab0.num_doc,
    tab0.valor_base,
    tab0.num_dias,
    tab0.aporte_func,
    tab0.aporte_patrono,
    tab0.id_tipo_aporte,
    tab0.porcentaje_func,
    tab0.porcentaje_patrono,
    tab0.tarifa,
    tab0.id_periodo,
    tab1.razon_social as fondo, 
    tab2.descripcion as clase_fondo,
    tab3.codigo||' - '||tab3.descripcion as concepto,
    tab4.razon_social as nombre_apellido,
    tab4.num_doc || ' - ' || tab4.razon_social as nombre_completo

    from cont_liquida_aporte  tab0
    left join CONTRATISTA tab4 ON tab4.id_tipo_doc = tab0.id_tipo_doc and tab4.num_doc = tab0.num_doc            
    left join NO_MAE_FONDOS tab1 ON tab1.id_mae_fondos = tab0.id_mae_fondos
    left join NO_CLASE_FONDO tab2 ON tab2.id_clase_fondo = tab0.id_clase_fondo
    left join NO_CONCEP_NOMINA tab3 ON tab3.id_concep_nomina = tab0.id_concep_nomina
    WHERE tab0.id_periodo = $id_periodo 
    $whereFuncionarioNumDoc $whereFuncionarioTipoDoc
    $whereClaseFondo $whereMaestroFondos
    )

$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

            $records = CN_TABLE::executeSQL($sql);

            //Ejecuta sql
            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($records);
            $this->list_data = $records;

            $this->conn->commit();
        } catch (Exception $e) {

            $mensaje = "[generar_aportes] ERROR!!!";

            $this->status = 1;
            $this->mensajeError = $mensaje;
            $this->list_data = array();
            $this->logMessage($mensaje);
            $this->logMessage($e->getMessage());

            $this->conn->rollback();
        }
    }

    /**
     * Calcular FSP aporte funcionario
     * @param type $valor_base
     * @param type $salario_minimo
     * @return int
     */
    private function valor_base_fsp($valor_base, $salario_minimo, $valor_base_vac = 0) {

        $valor = 0;
        $valorfps1 = 0;
        $valorfps2 = 0;
        $porcentaje = 0;

        /*
         * Operaciones
         */

        if (($valor_base + $valor_base_vac) > ($salario_minimo * 4) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 16)) {
            $porcentaje = 1;
        } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 16) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 17)) {
            $porcentaje = 1.2;
        } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 17) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 18)) {
            $porcentaje = 1.4;
        } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 18) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 19)) {
            $porcentaje = 1.6;
        } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 19) && ($valor_base + $valor_base_vac) <= ($salario_minimo * 20)) {
            $porcentaje = 1.8;
        } elseif (($valor_base + $valor_base_vac) > ($salario_minimo * 20)) {
            $porcentaje = 2;
        }

        $valorfps1 = $valor_base * 0.5 / 100;
        $valorfps2 = $valor_base * ($porcentaje - 0.5) / 100;

        $valor = CN_TABLE::redondeoValor($valorfps1, -2) + CN_TABLE::redondeoValor($valorfps2, -2);

        $array_fsp = array(
            'valor_fsp' => $valor,
            'porcentaje_fsp' => $porcentaje
        );

        return $array_fsp;
    }

    /**
     * Reemplaza en la formula las constantes por valores de la tabla NO_CONSTANTE
     * Ejemplo: $con_1
     * @param type $formula
     * @param type $arrayConstantes
     */
    private function reemplazoConstante($formula, $arrayConstantes) {

        /*
         * Recorrer array de Constantes
         */
        foreach ($arrayConstantes as $key => $value) {

            $formula = str_replace($key, $value['valor'], $formula);
        }

        return $formula;
    }

    /**
     * Reemplaza los parametros(variables) a la formula
     * Ejemplo: $key: C1 / $value: valor - 2+5
     * @param type $formula
     * @param type $arrayParametros
     */
    private function reemplazoParametros($formula, $arrayParametros) {

        /*
         * Recorrer array de Parametros
         */
        foreach ($arrayParametros as $key => $value) {

            $formula = str_replace('{' . $key . '}', $value, $formula);
        }

        return $formula;
    }

    /**
     * Obtener resultados de los parametros(variables)
     * Ejemplo: 'C1' => '0'
     * @param type $arrayParametros
     * @param type $record_liq
     */
    private function resultadoParametros($arrayParametros, $record_liq, $record_consulta) {

        /*
         * Recorrer array de Parametros
         */
        foreach ($arrayParametros as $key => $value) {

            //Sacar caracter y numero(id_concep_nomina) para consulta
            $caracter = substr($key, 0, 1);
            $id_concep_nomina = substr($key, 1);
            $this->logMessage("[Liquidación] Caracter: " . $caracter . ", numero: " . $id_concep_nomina);

            /*
             * Obtener consulta por caracter
             */
//            //Sql
//            $sql = <<<EOD
//select * from NO_CONSULTA where caracter = '$caracter' 
//EOD;
//            //Ejecutar SQL
//            $record = CN_TABLE::executeSQL($sql);
            //Validar registros SQL
            if (count($record_consulta) > 0) {
//                $this->logMessage("[Liquidación] Caracter: " . $record_consulta[$caracter]['caracter'] . ", consulta: " . $record_consulta[$caracter]['consulta']);
//                die();
//                $consulta = $record[0]['consulta'];
                $consulta = $record_consulta[$caracter]['consulta'];

                //Reemplazo de id_concep_nomina
                $consulta = str_replace('$id_concep_nomina', $id_concep_nomina, $consulta);

                /*
                 * Reemplaza en la consulta los filtros y valores del SQL, que vienen en el record
                 * Ejemplo: select raz_soc from id_cia where id_cia = $id_cia
                 * Reemplaza $id_cia por el valor en el record
                 */
                $consulta = CN_TABLE::reemplazoConsulta($consulta, $record_liq);

                /*
                 * Ejecutar SQL de consulta
                 */
                //Sql
                $sql = <<<EOD
$consulta  
EOD;
                //Ejecutar SQL
                $record = CN_TABLE::executeSQL($sql);

                //Validar registros SQL
                if (count($record) > 0) {
                    $valor = $record[0]['valor'];
                } else {
                    $valor = 0;
                }
            } else {
                $valor = 0;
            }

            $arrayParametros[$key] = $valor;
        }

        return $arrayParametros;
    }

    /**
     * Parser de la formula para obtener parametros(variables)
     * Ejemplo: 'C1' => '0'
     * @param type $formula
     * @param type $arrayParametros
     */
    private function parametrosFormula($formula) {

        $vars = array();

        CN_TABLE::getVarsInFormula($vars, $formula);

        foreach ($vars as $var) {
            $arrayParametros[$var] = 0;
        }

//        var_dump($arrayParametros);
//        exit();
//        $arrayParametros = array(
//            'C1' => '0',
//            'C2' => '0',
//            'T1' => '0',
//            'A1' => '0'
//        );

        return $arrayParametros;
    }

    /**
     * Reemplaza las agrupaciones por los parametros(variables)
     * Ejemplo: A1 -> (+C1-C2-T1)
     * @param type $id_agrup_var
     */
    private function reemplazoAgrupacion($id_agrup_var) {

        $agrup = '( ';

        /*
         * Ejecutar SQL de agrupciones
         */
        //Sql
        $sql = <<<EOD
select 
agru.*,
agru.tipo_valor as caracter
from
no_agrup_deta agru
where agru.id_agrup_concepto = $id_agrup_var  
EOD;
        //Ejecutar SQL
        $records = CN_TABLE::executeSQL($sql);

        /*
         * Recorrer registros 
         */
        foreach ($records as $value) {

            $operador = ($value['operador'] == 1 ? '+' : '-');

            //Concatenar todas las agrupaciones
            $agrup .= $operador . '{' . $value['caracter'] . $value['id_concep_nomina'] . '}';
        }

        $agrup .= ' )';

        return $agrup;
    }

}
